<?php
// $Id: graphael_example.graphs.inc,v 1.5 2010/08/24 14:47:03 mikl Exp $

/**
 * @file
 * gRaphaël example graphs.
 */

/**
 * Page callback for showing our examples.
 */
function graphael_example_graphs_page() {
  $output = array();

  $popdata = graphael_example_world_population_data();

  $output[] = '<h4>' . t('World population by continent') . '</h4>';

  $output[] = theme('graphael', 'bar', $popdata[2000], array(
    'colors' => array('#490A3D', '#BD1550', '#E97F02', '#F8CA00', '#8A9B0F', '#68B3AF'),
    'font' => '10px Arial, sans-serif',
    'opts' => array(
      'gutter' => '80%',
    ),
  ), array(
    'label' => array(
      'values' => array('Africa', 'Asia', 'Europe', 'Latin America', 'Northern America', 'Oceania'),
      'params' => array('attrText' => array(
        'fill' =>  '#aaa',
        'font' => '10px Arial, sans-serif',
      )),
    ),
  ));

  $output[] = '<h4>' . t('Population growth by continent') . '</h4>';

  $x_axis = array_keys($popdata);
  $y_axis = array();
  foreach ($popdata as $year) {
    foreach ($year as $key => $country) {
      $y_axis[$key][] = $country;
    }
  }
  $output[] = theme('graphael', 'line', array($x_axis, $y_axis), array(
    'opts' => array(
      'axis' => "0 0 1 1",
      'gutter' => 30,
  )), array(
    'label' => array(
      'params' => array('attrText' => array(
        'fill' =>  '#aaa',
        'font' => '10px Arial, sans-serif',
      )),
    ),
  ), array(
    'style' => 'height: 400px;width:600px;',
  ));

  $output[] = '<h4>' . t('World land mass by continent') . '</h4>';

  $output[] = theme('graphael', 'pie', graphael_example_world_landmass_data(), array(
    'colors' => array('#490A3D', '#444', '#BD1550', '#68B3AF', '#E97F02', '#F8CA00', '#8A9B0F'),
    'opts' => array(
      'gutter' => '80%',
      'legend' => array(
        '%%.% – Africa',
        '%%.% – Antarctica',
        '%%.% – Asia',
        '%%.% – Australia',
        '%%.% – Europe',
        '%%.% – South America',
        '%%.% – North America',
      ),
      'legendpos' => 'west',
    ),
  ));

  return join($output);
}

/**
 * World population example data.
 */
function graphael_example_world_population_data() {
  return array(
    // Africa, Asia, Europe, Latin America, North America, Oceania
    '1750' => array(106, 502, 163, 16, 2, 2),
    '1800' => array(107, 635, 203, 24, 7, 2),
    '1850' => array(111, 809, 276, 38, 26, 2),
    '1900' => array(133, 947, 408, 74, 82, 6),
    '1950' => array(211, 1398, 547, 167, 172, 12.8),
    '2000' => array(796, 3680, 728, 520, 316, 31),
  );
}

/**
 * World landmass example data.
 */
function graphael_example_world_landmass_data() {
  // Africa, Antarctica, Asia, Australia, Europe, South America, North America
  return array(30370000, 13720000, 43820000, 9008500, 10180000, 17840000, 24490000);
}

